net.sf.saxon.expr.sort

## Class AtomicSortComparer

- java.lang.Object
- - net.sf.saxon.expr.sort.AtomicSortComparer

- All Implemented Interfaces:
    Serializable, AtomicComparer
  Direct Known Subclasses:
    EquivalenceComparer

      public class AtomicSortComparer
      extends Object
      implements AtomicComparer

  An AtomicComparer used for comparing atomic values of arbitrary item types. It encapsulates a collator that is used when the values to be compared are strings. It also supports a separate method for testing equality of items, which can be used for data types that are not ordered. The AtomicSortComparer is identical to the GenericAtomicComparer except for its handling of NaN: it treats NaN values as lower than any other value, and as equal to each other.
  Author:
    Michael H. Kay
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static StructuredQName` | `COLLATION_KEY_NaN`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AtomicSortComparer(StringCollator collator, int itemType, XPathContext context)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
    `protected int` | `compareNonComparables(AtomicValue a, AtomicValue b)` Compare two values that are known to be non-comparable.
    `boolean` | `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
    `StringCollator` | `getCollator()` Get the collation used by this AtomicComparer if any
    `ComparisonKey` | `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
    `int` | `getItemType()` Get the requested item type
    `StringCollator` | `getStringCollator()` Get the underlying StringCollator
    `static AtomicComparer` | `makeSortComparer(StringCollator collator, int itemType, XPathContext context)` Factory method to get an atomic comparer suitable for sorting or for grouping (operations in which NaN is considered equal to NaN)
    `AtomicComparer` | `provideContext(XPathContext context)` Supply the dynamic context in case this is needed for the comparison

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### COLLATION_KEY_NaN

          public static StructuredQName COLLATION_KEY_NaN

  - ### Constructor Detail

    - #### AtomicSortComparer

          protected AtomicSortComparer(StringCollator collator,
                            int itemType,
                            XPathContext context)

  - ### Method Detail

    - #### makeSortComparer

          public static AtomicComparer makeSortComparer(StringCollator collator,
                                        int itemType,
                                        XPathContext context)

      Factory method to get an atomic comparer suitable for sorting or for grouping (operations in which NaN is considered equal to NaN)
      Parameters:
        `collator` - Collating comparer to be used when comparing strings. This argument may be null if the itemType excludes the possibility of comparing strings. If the method is called at compile time, this should be a SimpleCollation so that it can be cloned at run-time.
        `itemType` - the primitive item type of the values to be compared
        `context` - Dynamic context (may be an EarlyEvaluationContext)
      Returns:
        a suitable AtomicComparer

    - #### getCollator

          public StringCollator getCollator()

      Description copied from interface: `AtomicComparer`
      Get the collation used by this AtomicComparer if any
      Specified by:
        `getCollator` in interface `AtomicComparer`
      Returns:
        the collation used for comparing strings, or null if not applicable

    - #### provideContext

          public AtomicComparer provideContext(XPathContext context)

      Supply the dynamic context in case this is needed for the comparison
      Specified by:
        `provideContext` in interface `AtomicComparer`
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

    - #### getStringCollator

          public StringCollator getStringCollator()

      Get the underlying StringCollator
      Returns:
        the underlying collator

    - #### getItemType

          public int getItemType()

      Get the requested item type
      Returns:
        the item type

    - #### compareAtomicValues

          public int compareAtomicValues(AtomicValue a,
                                AtomicValue b)
                                  throws NoDynamicContextException

      Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.
      Specified by:
        `compareAtomicValues` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared. It is intended that this should normally be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
        `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
      Returns:
        <0 if a0 if a>b
      Throws:
        `ClassCastException` - if the objects are not comparable
        `NoDynamicContextException` - if this comparer required access to dynamic context information, notably the implicit timezone, and this information is not available. In general this happens if a context-dependent comparison is attempted at compile-time, and it signals the compiler to generate code that tries again at run-time.

    - #### compareNonComparables

          protected int compareNonComparables(AtomicValue a,
                                  AtomicValue b)

      Compare two values that are known to be non-comparable. In the base class this method throws a ClassCastException. In a subclass it is overridden to return `SequenceTool.INDETERMINATE_ORDERING`

    - #### comparesEqual

          public boolean comparesEqual(AtomicValue a,
                              AtomicValue b)
                                throws NoDynamicContextException

      Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.
      Specified by:
        `comparesEqual` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the equals() method.
        `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
      Returns:
        true if the values are equal, false if not
      Throws:
        `ClassCastException` - if the objects are not comparable
        `NoDynamicContextException`

    - #### getComparisonKey

          public ComparisonKey getComparisonKey(AtomicValue a)
                                         throws NoDynamicContextException

      Get a comparison key for an object. This must satisfy the rule that if two objects are equal, then their comparison keys are equal, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.
      Specified by:
        `getComparisonKey` in interface `AtomicComparer`
      Throws:
        `NoDynamicContextException`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.